PRESENTATION Annot;

VIEWS
   Formatted_view;

#ifdef PAGE
PRINT
   Formatted_view;
#endif

#define DOC_FONTSIZE 12 pt
#define RDF_FONTSIZE 12 pt
#define STRUCT_INDENT 0.5 cm
#define RDF_FgColor Black
#define RDF_BgColor Yellow

DEFAULT
	BEGIN
	HorizRef: Enclosed . HRef;
	VertRef: * . Left;
	Width: Enclosed . Width;
	Height: Enclosed . Height;
	VertPos: Top = Previous . Bottom;
	HorizPos: Left = Enclosing . Left;
	Justify: Enclosing =;
	Hyphenate: Enclosing =;
	LineSpacing: Enclosing =;
	LineWeight: Enclosing =;
	LineBreak: Yes;
	PageBreak: Yes;
	Visibility: Enclosing =;
	Font: Enclosing =;
	Style: Enclosing =;
	Weight: Enclosing =;
	Underline: Enclosing =;
	Thickness: Enclosing =;
	Size: Enclosing =;
	Adjust: Enclosing =;
	Indent: Enclosing =;
	Depth: Enclosing =;
	FillPattern: nopattern;
	END;

BOXES

 Author_Box:
	BEGIN
	Content: (Text 'Author: ');
	Visibility: Creator =;
	HorizPos: Left = Enclosing . Left + STRUCT_INDENT;
	VertPos: Top = Previous . Bottom + 0.2;
	Font: Creator =;
	Style: Creator =;
	Weight: Creator =;
	Size: RDF_FONTSIZE;
        Foreground: RDF_FgColor;
        Background: RDF_BgColor;
	END;

 SourceDoc_Box:
	BEGIN
	Content: (Text 'Source document: ');
	Visibility: Creator =;
	HorizPos: Left = Enclosing . Left + STRUCT_INDENT;
	VertPos: Top = Previous . Bottom + 0.2;
	Font: Creator =;
	Style: Creator =;
	Weight: Creator =;
	Size: RDF_FONTSIZE;
        Foreground: RDF_FgColor;
        Background: RDF_BgColor;

	END;

 RDFtype_Box:
	BEGIN
	Content: (Text 'Annotation type: ');
	Visibility: Creator =;
	HorizPos: Left = Enclosing . Left + STRUCT_INDENT;
	VertPos: Top = Previous . Bottom + 0.2;
	Font: Creator =;
	Style: Creator =;
	Weight: Creator =;
	Size: RDF_FONTSIZE;
        Foreground: RDF_FgColor;
        Background: RDF_BgColor;
	END;

 CDate_Box:
	BEGIN
	Content: (Text 'Created: ');
	HorizPos: Left = Enclosing . Left + STRUCT_INDENT;
	VertPos: Top = Previous . Bottom + 0.2;
	Font: Creator =;
	Style: Creator =;
	Weight: Creator =;
	Size: RDF_FONTSIZE;
        Foreground: RDF_FgColor;
        Background: RDF_BgColor;
	END;

 MDate_Box:
	BEGIN
	Content: (Text 'Last modified: ');
	Visibility: Creator =;
	HorizPos: Left = Enclosing . Left + STRUCT_INDENT;
	VertPos: Top = Previous . Bottom + 0.2;
	Font: Creator =;
	Style: Creator =;
	Weight: Creator =;
	Size: RDF_FONTSIZE;
        Foreground: RDF_FgColor;
        Background: RDF_BgColor;
	END;

 ValueType: BEGIN
	Content: (Resource);
	HorizPos: Left = Previous . Right;
	VertPos: HRef = Previous . HRef;
	END;

RULES

  Annot:
	BEGIN
	Adjust: Left;
	Justify: No;
	Indent: 0;
	Font: Helvetica;
	Style: Roman;
	Weight: Normal;
	LineWeight: 0;
	Width: Enclosing . Width;
	Height: Enclosing . Height min;
	Size: DOC_FONTSIZE;
	HorizPos: Left = Enclosing . Left;
	VertPos: Top = Enclosing . Top;
	END;

 Description:
	BEGIN
	Visibility: Enclosing =;
	Width: Right = Enclosing . Right - STRUCT_INDENT;
	HorizPos: Left = Enclosing . Left + STRUCT_INDENT;
	MarginTop: 1 px;
	MarginLeft: 1 px;
	MarginBottom: 1 px;
	MarginRight: 1 px;
	PaddingTop: 1 px;
	PaddingLeft: 1 px;
	PaddingBottom: 1 px;
	PaddingRight: 1 px;
	BorderTopWidth: 1 px;
	BorderLeftWidth: 1 px;
	BorderBottomWidth: 1 px;
	BorderRightWidth: 1 px;
	BorderTopColor: Black;
	BorderLeftColor: Black;
	BorderBottomColor: Black;
	BorderRightColor: Black;
	BorderTopStyle: Solid;
	BorderLeftStyle: Solid;
	BorderBottomStyle: Solid;
	BorderRightStyle: Solid;
	Background:  LightCoral4;
	FillPattern: backgroundcolor;
	Foreground: DarkSkyBlue3;
	END;

 Body:
	BEGIN
	Width: Enclosing . Width;
	Height: 1 cm min;
	HorizPos: Left = Enclosing . Left;
	VertPos: Top = Previous . Bottom + 0.2;
	Font: Times;
	END;

 Author:
	BEGIN
	CreateBefore (Author_Box);
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right;
	END;

 CreatorEmail:
	BEGIN
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right + 0.2;
	END;

 CreatorGivenName:
	BEGIN
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right + 0.2;
	END;

 CreatorFamilyName:
	BEGIN
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right + 0.2;
	END;

 SourceDoc:
	BEGIN
	CreateBefore (SourceDoc_Box);
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right;
	END;

 RDFtype:
	BEGIN
	CreateBefore (RDFtype_Box);
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right;
	Width: 1 px;
	END;

 AnnotCDate:
	BEGIN
	CreateBefore (CDate_Box);
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right;
	END;

 AnnotMDate:
	BEGIN
	CreateBefore (MDate_Box);
	VertPos: HRef = Previous . HRef;
	HorizPos: Left = Previous . Right;
	END;

ATTRIBUTES

 Resource:
	BEGIN
 	CreateBefore(ValueType);
        END;

END
